diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 794f9735e..6ad285d9e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -281,213 +256,195 @@ public class ScreenMainMenu extends Screen
             }
         }
 
-        if (mc.gameSettings.playTitleScreenMusic.value) {
-            mc.sndManager.playTitleScreenMusic();
+        if (this.mc.gameSettings.playTitleScreenMusic.value) {
+            this.mc.sndManager.playTitleScreenMusic();
         }
     }
 
     @Override
-    public void mouseClicked(int mx, int my, int buttonNum)
-    {
+    public void mouseClicked(int mx, int my, int buttonNum) {
         super.mouseClicked(mx, my, buttonNum);
 
         int logoWidth = 274;
-        int logoX = width / 2 - logoWidth / 2;
+        int logoX = this.width / 2 - logoWidth / 2;
         int logoHeight = 30;
         int p = 8;
-        if (mx >= logoX + p && mx <= logoX + 270 - p && my >= logoHeight + p && my <= logoHeight + 48 - p)
-        {
-            if (logoClickCounter >= 0)
-            {
-                indexToDraw = rand.nextInt(BLOCKS_TO_DRAW.length);
-                mc.gameSettings.alphaMenu.toggle();
-                if (mc.gameSettings.alphaMenu.value) logoBlocks = null;
-                logoClickCounter = 0;
-            }
-            else
-            {
-                logoClickCounter++;
+        if (mx >= logoX + p && mx <= logoX + 270 - p && my >= logoHeight + p && my <= logoHeight + 48 - p) {
+            if (this.logoClickCounter >= 0) {
+                this.indexToDraw = rand.nextInt(BLOCKS_TO_DRAW.length);
+                this.mc.gameSettings.alphaMenu.toggle();
+                if (this.mc.gameSettings.alphaMenu.value) this.logoBlocks = null;
+                this.logoClickCounter = 0;
+            } else {
+                this.logoClickCounter++;
             }
         }
-        if (my >= 2 && my <= 12)
-        {
-            if (mx >= 2 && mx <= 40)
-            {
-                showBuildTime = !showBuildTime;
+        if (my >= 2 && my <= 12) {
+            if (mx >= 2 && mx <= 40) {
+                this.showBuildTime = !this.showBuildTime;
             }
         }
     }
 
     @Override
-    public void render(int mx, int my, float partialTick)
-    {
+    public void render(int mx, int my, float partialTick) {
         I18n i18n = I18n.getInstance();
         renderBackground();
         int c = 274;
-        int k = width / 2 - c / 2;
+        int k = this.width / 2 - c / 2;
         byte byte0 = 30;
-        if (!mc.gameSettings.alphaMenu.value)
-        {
-            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            drawTexturedModalRect(k, byte0, 0, 0, 274, 50, 1d/274, 1d/50);
-        }
-        else
-        {
+        if (!this.mc.gameSettings.alphaMenu.value) {
+            this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+            drawTexturedModalRect(k, byte0, 0, 0, 274, 50, 1d / 274, 1d / 50);
+        } else {
             drawLogo(partialTick);
         }
 
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/snowflake.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/snowflake.png").bind();
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
 
         // Render snow particles on title screen on Christmas
-        if(Holidays.getCurrentThemedHoliday() == Holidays.XMAS) {
-            for (Snowflake snowflake : snowflakes) {
+        if (Holidays.getCurrentThemedHoliday() == Holidays.XMAS) {
+            for (Snowflake snowflake : this.snowflakes) {
                 drawTexturedModalRectDouble(snowflake.flakeX, snowflake.flakeY, 0, 4 * snowflake.texIndex, 4, 4, 1d / 4, 1d / 16);
             }
         }
 
-        GL11.glPushMatrix();
-        GL11.glTranslatef(width / 2 + 140, 80F, 0.0F);
-        GL11.glRotatef(-20F, 0.0F, 0.0F, 1.0F);
-        float f1 = 1.8F - MathHelper.abs(MathHelper.sin(((float)(System.currentTimeMillis() % 1000L) / 1000F) * MathHelper.PI * 2.0F) * 0.1F);
-        f1 = (f1 * 100F) / (float)(fontRenderer.stringWidthDouble(splashText) + 32);
-        GL11.glScalef(f1, f1, f1);
-        drawStringCenteredShadow(fontRenderer, splashText, 0, -8, 0xffff00);
-        GL11.glPopMatrix();
-        int versionTextColor = mc.gameSettings.alphaMenu.value || !mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
-        if (showBuildTime) {
-            drawStringShadow(fontRenderer, buildTimeString, 2, 2, versionTextColor);
+        GLRenderer.pushFrame();
+        GLRenderer.modelM4f().translate(this.width / 2 + 140, 80F, 0.0F);
+        GLRenderer.modelM4f().rotateZ(Math.toRadians(-20F));
+        float scalar = 1.8F - MathHelper.abs(MathHelper.sin(((float) (System.currentTimeMillis() % 1000L) / 1000F) * MathHelper.PI * 2.0F) * 0.1F);
+        scalar = (scalar * 100F) / (float) (this.fontRenderer.stringWidthDouble(this.splashText) + 32);
+        GLRenderer.modelM4f().scale(scalar, scalar, scalar);
+        drawStringCenteredShadow(this.fontRenderer, this.splashText, 0, -8, 0xffff00);
+        GLRenderer.popFrame();
+        int versionTextColor = this.mc.gameSettings.alphaMenu.value || !this.mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
+        if (this.showBuildTime) {
+            drawStringShadow(this.fontRenderer, this.buildTimeString, 2, 2, versionTextColor);
         } else {
-            drawStringShadow(fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
+            drawStringShadow(this.fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
         }
         String disclaimer1 = i18n.translateKey("gui.main_menu.label.disclaimer.1");
-        drawStringShadow(fontRenderer, disclaimer1, width - MathHelper.ceil(fontRenderer.stringWidthDouble(disclaimer1)) - 2, height - 20, 0xffffff);
+        drawStringShadow(this.fontRenderer, disclaimer1, this.width - MathHelper.ceil(this.fontRenderer.stringWidthDouble(disclaimer1)) - 2, this.height - 20, 0xffffff);
         String disclaimer2 = i18n.translateKey("gui.main_menu.label.disclaimer.2");
-        drawStringShadow(fontRenderer, disclaimer2, width - MathHelper.ceil(fontRenderer.stringWidthDouble(disclaimer2)) - 2, height - 10, 0xffffff);
+        drawStringShadow(this.fontRenderer, disclaimer2, this.width - MathHelper.ceil(this.fontRenderer.stringWidthDouble(disclaimer2)) - 2, this.height - 10, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
     private void drawLogo(final float partialTick) {
-        int var3;
-        if(this.logoBlocks == null) {
+        if (this.logoBlocks == null) {
             this.logoBlocks = new LogoBlock[logoBlockLayers[0].length()][logoBlockLayers.length];
 
-            for(int x = 0; x < this.logoBlocks.length; ++x) {
-                for(int y = 0; y < this.logoBlocks[x].length; ++y) {
+            for (int x = 0; x < this.logoBlocks.length; ++x) {
+                for (int y = 0; y < this.logoBlocks[x].length; ++y) {
                     this.logoBlocks[x][y] = new LogoBlock(x, y);
                 }
             }
         }
 
-        GL11.glMatrixMode(GL11.GL_PROJECTION);
-        GL11.glPushMatrix();
-        GL11.glLoadIdentity();
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
         final int delta = this.mc.gameWindow.getWidthPixels() / this.mc.resolution.getScaledWidthScreenCoords();
-        var3 = 120 * delta;
-        GLU.gluPerspective(70.0F, (float)this.mc.gameWindow.getWidthPixels() / (float)var3, 0.05F, 100.0F);
-        GL11.glViewport(0, this.mc.gameWindow.getHeightPixels() - var3, this.mc.gameWindow.getWidthPixels(), var3);
-        GL11.glMatrixMode(GL11.GL_MODELVIEW);
-        GL11.glPushMatrix();
-        GL11.glLoadIdentity();
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        GL11.glCullFace(GL11.GL_BACK);
-        GL11.glDepthMask(true);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        int var3 = 120 * delta;
+        GLRenderer.projectionM4f().identity().perspective(70.0F, (float) this.mc.gameWindow.getWidthPixels() / (float) var3, 0.05F, 100.0F);
+        GLRenderer.viewM4f().identity();
+        GL41.glViewport(0, this.mc.gameWindow.getHeightPixels() - var3, this.mc.gameWindow.getWidthPixels(), var3);
+
+        GLRenderer.modelM4f().identity();
+        GLRenderer.disableState(State.CULL_FACE);
+        GLRenderer.setCullFace(CullFace.BACK);
+        GLRenderer.setDepthMask(true);
+        GLRenderer.enableState(State.DEPTH_TEST);
         Lighting.enableLight(0.5f, 0.16f);
 
-        for(int renderPass = 0; renderPass < 3; ++renderPass) {
-            GL11.glPushMatrix();
-            GL11.glTranslatef(0.4F, 0.6F, -12.0F);
+        for (int renderPass = 0; renderPass < 3; ++renderPass) {
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(0.4F, 0.6F, -12.0F);
             switch (renderPass) {
                 case 0:
-                    GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
-                    GL11.glTranslatef(0.0F, -0.4F, 0.0F);
-                    GL11.glScalef(0.98F, 1.0F, 1.0F);
-                    GL11.glEnable(GL11.GL_BLEND);
-                    GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+                    GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
+                    GLRenderer.modelM4f().translate(0.0F, -0.4F, 0.0F);
+                    GLRenderer.modelM4f().scale(0.98F, 1.0F, 1.0F);
+                    GLRenderer.enableState(State.BLEND);
+                    GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
                     break;
                 case 1:
-                    GL11.glDisable(GL11.GL_BLEND);
-                    GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
+                    GLRenderer.disableState(State.BLEND);
+                    GL41.glClear(GL41.GL_DEPTH_BUFFER_BIT);
                     break;
                 case 2:
-                    GL11.glEnable(GL11.GL_BLEND);
-                    GL11.glBlendFunc(GL11.GL_SRC_COLOR, GL11.GL_ONE);
+                    GLRenderer.enableState(State.BLEND);
+                    GLRenderer.setBlendFunc(BlendFactor.SRC_COLOR, BlendFactor.ONE);
                     break;
             }
 
-            GL11.glScalef(1.0F, -1.0F, 1.0F);
-            GL11.glRotatef(15.0F, 1.0F, 0.0F, 0.0F);
-            GL11.glScalef(0.89F, 1.0F, 0.4F);
-            GL11.glTranslatef((float)(-logoBlockLayers[0].length()) * 0.5F, (float)(-logoBlockLayers.length) * 0.5F, 0.0F);
-            TextureRegistry.blockAtlas.bind();
-            if(renderPass == 0) {
+            GLRenderer.modelM4f().scale(1.0F, -1.0F, 1.0F);
+            GLRenderer.modelM4f().rotateX(Math.toRadians(15.0F));
+            GLRenderer.modelM4f().scale(0.89F, 1.0F, 0.4F);
+            GLRenderer.modelM4f().translate((float) (-logoBlockLayers[0].length()) * 0.5F, (float) (-logoBlockLayers.length) * 0.5F, 0.0F);
+            TextureRegistry.worldAtlas.bind();
+            if (renderPass == 0) {
                 this.mc.textureManager.loadTexture("/title/black.png").bind();
             }
 
-            for(int y = 0; y < logoBlockLayers.length; ++y) {
-                for(int x = 0; x < logoBlockLayers[y].length(); ++x) {
+            for (int y = 0; y < logoBlockLayers.length; ++y) {
+                for (int x = 0; x < logoBlockLayers[y].length(); ++x) {
                     char c = logoBlockLayers[y].charAt(x);
-                    if(c != ' ') {
-                        GL11.glPushMatrix();
+                    if (c != ' ') {
+                        GLRenderer.pushFrame();
                         final LogoBlock logoBlock = this.logoBlocks[x][y];
-                        float z = (float)(logoBlock.prevHeight + (logoBlock.height - logoBlock.prevHeight) * (double)partialTick);
+                        float z = (float) (logoBlock.prevHeight + (logoBlock.height - logoBlock.prevHeight) * (double) partialTick);
                         float scale = 1.0F;
                         float alpha = 1.0F;
-                        if(renderPass == 0) {
+                        if (renderPass == 0) {
                             scale = z * 0.04F + 1.0F;
                             alpha = 1.0F / scale;
                             z = 0.0F;
                         }
 
-                        GL11.glTranslatef(x, y, z);
-                        GL11.glScalef(scale, scale, scale);
-                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(Tessellator.instance, 0, 1f, alpha, null);
-                        GL11.glPopMatrix();
+                        GLRenderer.setColor4f(1f, 1f, 1f, alpha);
+                        GLRenderer.modelM4f().translate(x, y, z);
+                        GLRenderer.modelM4f().scale(scale, scale, scale);
+                        BlockModelDispatcher.getInstance().getDispatch(BLOCKS_TO_DRAW[this.indexToDraw]).renderStandalone(GLRenderer.getTessellator(), 0, LightmapHelper.getLightmapCoord(15, 15));
+                        GLRenderer.popFrame();
                     }
                 }
             }
 
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
         Lighting.disable();
-
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glMatrixMode(GL11.GL_PROJECTION);
-        GL11.glPopMatrix();
-        GL11.glMatrixMode(GL11.GL_MODELVIEW);
-        GL11.glPopMatrix();
-        GL11.glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
-        GL11.glEnable(GL11.GL_CULL_FACE);
+        GLRenderer.popFrame();
+        GL41.glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
     }
 
     public static void loadLogo() {
-    	try {
-    		InputStream inputStream = ScreenMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
-    		BufferedImage image = ImageIO.read(inputStream);
-    		inputStream.close();
-
-    		logoBlockLayers = new String[image.getHeight()];
-    		
-    		for(int i=0; i < image.getHeight(); i++) {
-    			StringBuilder builder = new StringBuilder();
-    			
-    			for(int j=0; j < image.getWidth(); j++) {
-    				int rgb = image.getRGB(j, i);
-    				
-    				if(((rgb >> 16) & 0xFF) > 0x80) {
-    					builder.append('*');
-    				}else {
-    					builder.append(' ');
-    				}
-    			}
-    			
-    			logoBlockLayers[i] = builder.toString();
-    		}
-    	}catch (Exception e) {
+        try {
+            InputStream inputStream = ScreenMainMenu.class.getResourceAsStream("/assets/minecraft/textures/gui/title/retrologo.png");
+            BufferedImage image = ImageIO.read(inputStream);
+            inputStream.close();
+
+            logoBlockLayers = new String[image.getHeight()];
+
+            for (int i = 0; i < image.getHeight(); i++) {
+                StringBuilder builder = new StringBuilder();
+
+                for (int j = 0; j < image.getWidth(); j++) {
+                    int rgb = image.getRGB(j, i);
+
+                    if (((rgb >> 16) & 0xFF) > 0x80) {
+                        builder.append('*');
+                    } else {
+                        builder.append(' ');
+                    }
+                }
+
+                logoBlockLayers[i] = builder.toString();
+            }
+        } catch (Exception e) {
             LOGGER.error("Exception while loading retro logo!", e);
-		}
+        }
     }
 
     static class Snowflake {
@@ -513,32 +470,32 @@ public class ScreenMainMenu extends Screen
         public void updateEffects() {
             this.flakeY += this.dropSpeed * 0.3f;
             this.flakeX += this.verticalSpeed * 1.5f;
-            if(this.flakeY > maxHeight) {
+            if (this.flakeY > this.maxHeight) {
                 this.flakeY = 0;
-                this.flakeX = flakeXO;
+                this.flakeX = this.flakeXO;
             }
         }
     }
-    
+
     static class LogoBlock {
-    	
+
         public double height;
         public double prevHeight;
         public double dropSpeed;
 
         public LogoBlock(int x, int y) {
-            this.height = this.prevHeight = (double)(10 + y) + rand.nextDouble() * 32.0D + (double)x;
+            this.height = this.prevHeight = (double) (10 + y) + rand.nextDouble() * 32.0D + (double) x;
         }
 
         public void updateLogoEffects() {
             this.prevHeight = this.height;
-            if(this.height > 0.0D) {
+            if (this.height > 0.0D) {
                 this.dropSpeed -= 0.6D;
             }
 
             this.height += this.dropSpeed;
             this.dropSpeed *= 0.9D;
-            if(this.height < 0.0D) {
+            if (this.height < 0.0D) {
                 this.height = 0.0D;
                 this.dropSpeed = 0.0D;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
index 7fc9bbcc5..15313eae4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
@@ -1,146 +1,129 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.List;
 
-import static org.lwjgl.opengl.GL11.*;
-
 public class ScreenPaintingPicker
-    extends Screen
-{
+    extends Screen {
     private final Player player;
     private final List<ArtEntry> artEntries = new ArrayList<>();
     private ArtType centerArt = ArtType.Kebab;
     private int tallestSize = 0;
 
-    public ScreenPaintingPicker(Player player)
-    {
+    public ScreenPaintingPicker(Player player) {
         this.player = player;
-        for (ArtType art : ArtType.values){
-            if (art.sizeY > tallestSize) tallestSize = art.sizeY;
+        for (ArtType art : ArtType.values) {
+            if (art.sizeY > this.tallestSize) this.tallestSize = art.sizeY;
         }
     }
 
     @Override
     public void init() {
         super.init();
-        centerArt = player.getSelectedArt();
+        this.centerArt = this.player.getSelectedArt();
         updateArtEntries();
     }
 
     @Override
-    public void render(int mx, int my, float partialTick)
-    {
+    public void render(int mx, int my, float partialTick) {
         super.render(mx, my, partialTick);
 
         float dWheel = Mouse.getDWheel();
-        if (dWheel < 0)
-        {
-            centerArt = ArtType.getNext(centerArt);
+        if (dWheel < 0) {
+            this.centerArt = ArtType.getNext(this.centerArt);
             updateArtEntries();
-        }
-        else if (dWheel > 0)
-        {
-            centerArt = ArtType.getPrevious(centerArt);
+        } else if (dWheel > 0) {
+            this.centerArt = ArtType.getPrevious(this.centerArt);
             updateArtEntries();
         }
 
-        drawPaintings(width, height, mx, my);
+        drawPaintings(this.width, this.height, mx, my);
     }
 
     @Override
-    public void mouseClicked(int mx, int my, int buttonNum)
-    {
+    public void mouseClicked(int mx, int my, int buttonNum) {
         super.mouseClicked(mx, my, buttonNum);
-        int scale = getScale(width, height);
-
-        if (buttonNum == 0)
-        {
-            for (ArtEntry artEntry : artEntries)
-            {
-                if (mx >= artEntry.x && mx <= artEntry.x + artEntry.art.sizeX * scale && my >= artEntry.y && my <= artEntry.y + artEntry.art.sizeY * scale)
-                {
-                    mc.playerController.setPaintingType(artEntry.art);
-                    mc.displayScreen(null);
+        int scale = getScale(this.width, this.height);
+
+        if (buttonNum == 0) {
+            for (ArtEntry artEntry : this.artEntries) {
+                if (mx >= artEntry.x && mx <= artEntry.x + artEntry.art.sizeX * scale && my >= artEntry.y && my <= artEntry.y + artEntry.art.sizeY * scale) {
+                    this.mc.playerController.setPaintingType(artEntry.art);
+                    this.mc.displayScreen(null);
                     break;
                 }
             }
         }
     }
 
-    private void updateArtEntries()
-    {
-        int centerX = width / 2;
-        int centerY = height / 2;
+    private void updateArtEntries() {
+        int centerX = this.width / 2;
+        int centerY = this.height / 2;
 
-        int scale = getScale(width, height);
+        int scale = getScale(this.width, this.height);
         int offsetX = 32 * scale;
         int artGap = 2;
 
-        artEntries.clear();
+        this.artEntries.clear();
 
-        artEntries.add(new ArtEntry(centerArt, centerX - offsetX, centerY - ((centerArt.sizeY  * scale) / 2), 1.0f));
+        this.artEntries.add(new ArtEntry(this.centerArt, centerX - offsetX, centerY - ((this.centerArt.sizeY * scale) / 2), 1.0f));
 
-        ArtType currentArt = ArtType.getNext(centerArt);
+        ArtType currentArt = ArtType.getNext(this.centerArt);
 
-        int dy = ((centerArt.sizeY * scale) / 2 + artGap) + 28;
-        while (currentArt != centerArt)
-        {
+        int dy = ((this.centerArt.sizeY * scale) / 2 + artGap) + 28;
+        while (currentArt != this.centerArt) {
             int pCenterY = dy;
-            float alpha = 1 - (float) pCenterY / (height / 2f);
+            float alpha = 1 - (float) pCenterY / (this.height / 2f);
 
-            artEntries.add(new ArtEntry(currentArt, centerX - offsetX, centerY + dy, alpha * 0.75f));
+            this.artEntries.add(new ArtEntry(currentArt, centerX - offsetX, centerY + dy, alpha * 0.75f));
             dy += ((currentArt.sizeY * scale) + artGap);
             currentArt = ArtType.getNext(currentArt);
         }
 
-        currentArt = ArtType.getPrevious(centerArt);
-        dy = -((centerArt.sizeY  * scale) / 2);
-        while (currentArt != centerArt)
-        {
-            dy -= ((currentArt.sizeY  * scale) + artGap);
+        currentArt = ArtType.getPrevious(this.centerArt);
+        dy = -((this.centerArt.sizeY * scale) / 2);
+        while (currentArt != this.centerArt) {
+            dy -= ((currentArt.sizeY * scale) + artGap);
             int pCenterY = dy + currentArt.sizeY * scale;
-            float alpha = 1 - (float) -pCenterY / (height / 2f);
+            float alpha = 1 - (float) -pCenterY / (this.height / 2f);
 
-            artEntries.add(new ArtEntry(currentArt, centerX - offsetX, centerY + dy, alpha * 0.75f));
+            this.artEntries.add(new ArtEntry(currentArt, centerX - offsetX, centerY + dy, alpha * 0.75f));
             currentArt = ArtType.getPrevious(currentArt);
         }
     }
 
-    private void drawPaintings(int screenWidth, int screenHeight, int mouseX, int mouseY)
-    {
+    private void drawPaintings(int screenWidth, int screenHeight, int mouseX, int mouseY) {
         int centerX = screenWidth / 2;
         int centerY = screenHeight / 2;
 
         int scale = getScale(screenWidth, screenHeight);
         int offsetX = 32 * scale;
 
-        glEnable(GL_TEXTURE_2D);
-
-        drawStringShadow(fontRenderer, centerArt.title, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
-        drawStringShadow(fontRenderer, centerArt.artist, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
+        drawStringShadow(this.fontRenderer, this.centerArt.title, centerX - offsetX, centerY + (this.centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
+        drawStringShadow(this.fontRenderer, this.centerArt.artist, centerX - offsetX, centerY + (this.centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
 
-        glEnable(GL_BLEND);
-        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
-        for (ArtEntry entry : artEntries)
-        {
-            if (entry.alpha > 0)
-            {
-                GL11.glColor4f(1f, 1f, 1f, 1f);
-                if (mouseX > entry.x && mouseX < entry.x + entry.art.sizeX * scale && mouseY > entry.y && mouseY < entry.y + entry.art.sizeY * scale)
-                {
-                    GL11.glDisable(GL11.GL_TEXTURE_2D);
+        for (ArtEntry entry : this.artEntries) {
+            if (entry.alpha > 0) {
+                GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+                if (mouseX > entry.x && mouseX < entry.x + entry.art.sizeX * scale && mouseY > entry.y && mouseY < entry.y + entry.art.sizeY * scale) {
+                    GLRenderer.setShader(Shaders.COLOR);
                     drawRectWidthHeight(entry.x - scale, entry.y - scale, (entry.art.sizeX + 2) * scale, (entry.art.sizeY + 2) * scale, 0xFFFFFFFF);
-                    GL11.glEnable(GL11.GL_TEXTURE_2D);
+                    GLRenderer.setShader(Shaders.INTERFACE);
                     drawPainting(entry.art, entry.x, entry.y, entry.art.sizeX, entry.art.sizeY, 1f);
                 } else {
                     drawPainting(entry.art, entry.x, entry.y, entry.art.sizeX, entry.art.sizeY, entry.alpha);
@@ -148,43 +131,37 @@ public class ScreenPaintingPicker
 
             }
         }
-
-        glDisable(GL_TEXTURE_2D);
-        glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
 
-    private void drawPainting(ArtType art, int x, int y, int width, int height, float alpha)
-    {
+    private void drawPainting(ArtType art, int x, int y, int width, int height, float alpha) {
         int scale = getScale(this.width, this.height);
-        drawTexturedIconPainting(x, y, width * scale, height * scale,TextureRegistry.getTexture(art.texture), alpha);
+        drawTexturedIconPainting(x, y, width * scale, height * scale, TextureRegistry.getTexture(art.texture), alpha);
     }
 
-    public void drawTexturedIconPainting(int x, int y, int width, int height, IconCoordinate coordinate, float alpha)
-    {
+    public void drawTexturedIconPainting(int x, int y, int width, int height, IconCoordinate coordinate, float alpha) {
         coordinate.parentAtlas.bind();
-        Tessellator tessellator = Tessellator.instance;
-        GL11.glColor4f(1f, 1f, 1f, alpha);
+        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        GLRenderer.setColor4f(1f, 1f, 1f, alpha);
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(x + 0,      y + height, zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width,  y + height, zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
-        tessellator.addVertexWithUV(x + width,  y + 0,      zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
-        tessellator.addVertexWithUV(x + 0,      y + 0,      zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
+        tessellator.addVertexWithUV(x, y + height, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width, y + height, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMax());
+        tessellator.addVertexWithUV(x + width, y, this.zLevel, coordinate.getIconUMax(), coordinate.getIconVMin());
+        tessellator.addVertexWithUV(x, y, this.zLevel, coordinate.getIconUMin(), coordinate.getIconVMin());
         tessellator.draw();
     }
-    public int getScale(int width, int height)
-    {
-        return Math.min((int)((height * 0.9f)/tallestSize), mc.resolution.getScale());
+
+    public int getScale(int width, int height) {
+        return Math.min((int) ((height * 0.9f) / this.tallestSize), this.mc.resolution.getScale());
     }
 
-    private static final class ArtEntry
-    {
+    private static final class ArtEntry {
         public final ArtType art;
         public final int x;
         public final int y;
         public final float alpha;
 
-        public ArtEntry(ArtType art, int x, int y, float alpha)
-        {
+        public ArtEntry(ArtType art, int x, int y, float alpha) {
             this.art = art;
             this.x = x;
             this.y = y;
